Index: /trunk/SophyaPI/PI/Quartz/PI.xcodeproj/brunomansoux.pbxuser
===================================================================
--- /trunk/SophyaPI/PI/Quartz/PI.xcodeproj/brunomansoux.pbxuser	(revision 4076)
+++ /trunk/SophyaPI/PI/Quartz/PI.xcodeproj/brunomansoux.pbxuser	(revision 4077)
@@ -1453,24 +1420,4 @@
 		);
 	};
-	6DECAF30103EDEC600699E89 /* PBXTextBookmark */ = {
-		isa = PBXTextBookmark;
-		fRef = 6D98FCF4062C1CDB009E5976 /* PIWindowQuartz.h */;
-		name = "PIWindowQuartz.h: wParent";
-		rLen = 0;
-		rLoc = 1619;
-		rType = 0;
-		vrLen = 1642;
-		vrLoc = 24;
-	};
-	6DECAF31103EDEC600699E89 /* PBXTextBookmark */ = {
-		isa = PBXTextBookmark;
-		fRef = 6D98FCF5062C1CDB009E5976 /* PIWindowQuartz.cpp */;
-		name = "PIWindowQuartz.cpp: 42";
-		rLen = 0;
-		rLoc = 1018;
-		rType = 0;
-		vrLen = 1318;
-		vrLoc = 0;
-	};
 	6DECAF32103EDEC600699E89 /* PBXTextBookmark */ = {
 		isa = PBXTextBookmark;
@@ -1478,5 +1425,5 @@
 		name = "pigraphquartz.h: PIGraphicWin";
 		rLen = 0;
-		rLoc = 4635;
+		rLoc = 5000;
 		rType = 0;
 		vrLen = 1879;
@@ -1500,14 +1447,15 @@
 	6DF26D160E7FB7EC001AE7EF /* pibwdggen.cc */ = {
 		uiCtxt = {
-			sepNavIntBoundsRect = "{{0, 0}, {750, 11228}}";
-			sepNavSelRange = "{15441, 53}";
-			sepNavVisRect = "{{0, 6041}, {750, 858}}";
+			sepNavIntBoundsRect = "{{0, 0}, {763, 11228}}";
+			sepNavSelRange = "{5709, 18}";
+			sepNavVisRect = "{{0, 1890}, {763, 533}}";
 		};
 	};
 	6DF26D170E7FB7EC001AE7EF /* pibwdggen.h */ = {
 		uiCtxt = {
-			sepNavIntBoundsRect = "{{0, 0}, {881, 2254}}";
-			sepNavSelRange = "{2265, 0}";
-			sepNavVisRect = "{{0, 1190}, {881, 854}}";
+			sepNavIntBoundsRect = "{{0, 0}, {767, 2254}}";
+			sepNavSelRange = "{2026, 0}";
+			sepNavVisRect = "{{0, 0}, {767, 591}}";
+			sepNavWindowFrame = "{{67, 20}, {792, 956}}";
 		};
 	};
@@ -1591,14 +1539,14 @@
 	6DFD5AD406774017009E5976 /* PIApplQuartz.h */ = {
 		uiCtxt = {
-			sepNavIntBoundsRect = "{{0, 0}, {727, 859}}";
+			sepNavIntBoundsRect = "{{0, 0}, {767, 770}}";
 			sepNavSelRange = "{579, 0}";
-			sepNavVisRect = "{{0, 0}, {727, 859}}";
+			sepNavVisRect = "{{0, 0}, {767, 603}}";
 		};
 	};
 	6DFD5AD506774017009E5976 /* PIApplQuartz.cpp */ = {
 		uiCtxt = {
-			sepNavIntBoundsRect = "{{0, 0}, {813, 1414}}";
+			sepNavIntBoundsRect = "{{0, 0}, {767, 1414}}";
 			sepNavSelRange = "{757, 0}";
-			sepNavVisRect = "{{0, 336}, {813, 385}}";
+			sepNavVisRect = "{{0, 140}, {767, 603}}";
 		};
 	};
Index: /trunk/SophyaPI/PI/Quartz/PIContainerQuartz.h~
===================================================================
--- /trunk/SophyaPI/PI/Quartz/PIContainerQuartz.h~	(revision 4077)
+++ /trunk/SophyaPI/PI/Quartz/PIContainerQuartz.h~	(revision 4077)
@@ -0,0 +1,31 @@
+/*
+ *  PIContainerQuartz.h
+ *  PI
+ *
+ *  Created by Bruno MANSOUX on Tue May 04 2004.
+ *  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
+ *
+ */
+#include  <Carbon/Carbon.h>
+
+#ifndef PICONTAINERQUARTZ_SEEN
+#define PICONTAINERQUARTZ_SEEN
+
+#include "picontainergen.h"
+
+
+class PIContainerQuartz : public PIContainerGen 
+{
+public:
+    PIContainerQuartz(PIContainerGen *par, const char *nom,
+        int sx=10, int sy=10, int px=0, int py=0);
+    virtual	~PIContainerQuartz();
+
+    virtual void Process(PIMessage msg, PIMsgHandler* sender, void* data=NULL);
+	
+	virtual WindowRef GetWindowRef();
+};
+
+typedef PIContainerQuartz PIContainer;
+
+#endif  /* PICONTAINERQUARTZ_SEEN */
Index: /trunk/SophyaPI/PI/Quartz/machdefs.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/machdefs.h	(revision 4077)
+++ /trunk/SophyaPI/PI/Quartz/machdefs.h	(revision 4077)
@@ -0,0 +1,401 @@
+#ifndef MACHDEFS_SEEN
+#define MACHDEFS_SEEN
+
+/***********************************************************************/
+/* Find hardware, OS and compiler combination                          */
+/***********************************************************************/
+
+#if defined(OSF1) 
+#define MACH_ALPHA
+#define OS_OSF1
+#endif
+
+#if defined(_AIX) || defined(AIX)
+#define MACH_IBMRS
+#define OS_AIX
+#endif
+
+#if defined(__hpux__) || defined(HPUX)
+#define MACH_HP
+#define OS_HPUX
+#endif
+
+#ifdef __MWERKS__
+#define MACH_POWERMAC
+#define OS_MACOS
+#endif
+
+#if defined(SunOS)  || defined ( sun )
+#define MACH_SUN
+#define OS_SOLARIS
+#endif
+
+#ifdef IRIX64
+#define MACH_SGI
+#define OS_IRIX64
+#endif
+
+#ifdef __APPLE__
+#ifdef __MACH__
+#define MACH_POWERPC
+#define OS_MACOSX
+#endif
+#endif
+
+#if defined(Linux)  || defined(linux)
+#if defined(__alpha__)
+#define MACH_ALPHA
+#elif defined(powerpc)
+#define MACH_POWERPC
+#elif defined(__i386__)
+#define MACH_INTEL
+#else
+#error Undefined Platform (machine) type with linux in machdefs.h
+#endif
+#define OS_LINUX
+#endif
+
+
+/***********************************************************************/
+/* Hardware/OS dependent stuff                                         */
+/***********************************************************************/
+
+#if defined(OS_OSF1)
+
+  typedef signed char int_1;
+  typedef unsigned char uint_1;
+  typedef int int_4;
+  typedef unsigned int uint_4;
+  typedef short int_2;
+  typedef unsigned short uint_2;
+  typedef float r_4;
+  typedef double r_8;
+  typedef long long int_8;
+  typedef unsigned long long uint_8;
+
+#define  SWAP 1
+#define  SWAPDEFAUT 1
+
+#elif  defined(OS_HPUX)
+
+  typedef signed char int_1;
+  typedef unsigned char uint_1;
+  typedef int int_4 ;
+  typedef unsigned int uint_4;
+  typedef short int_2;
+  typedef unsigned short uint_2;
+  typedef float r_4;
+  typedef double r_8;
+  typedef long long int_8;
+  typedef unsigned long long uint_8;
+
+#define  SWAP 0
+#define  SWAPDEFAUT   0
+
+
+#elif  defined( OS_AIX )
+
+  typedef signed char int_1;
+  typedef unsigned char uint_1;
+  typedef int int_4;
+  typedef unsigned int uint_4;
+  typedef short int_2;
+  typedef unsigned short uint_2;
+  typedef float r_4;
+  typedef double r_8;
+  typedef long long int_8;
+  typedef unsigned long long uint_8;
+
+#define  SWAP 0
+#define  SWAPDEFAUT   0
+
+/* Check for solaris on intel... */
+#elif  defined( OS_SOLARIS ) && defined( MACH_SUN )
+
+  typedef signed char int_1;
+  typedef unsigned char uint_1;
+  typedef int int_4;
+  typedef unsigned int uint_4;
+  typedef short int_2;
+  typedef unsigned short uint_2;
+  typedef float r_4;
+  typedef double r_8;
+  typedef long long int_8;
+  typedef unsigned long long uint_8;
+
+#define  SWAP 0
+#define  SWAPDEFAUT   0
+
+#elif  defined( OS_IRIX64 )
+
+  typedef signed char int_1;
+  typedef unsigned char uint_1;
+  typedef int int_4;
+  typedef unsigned int uint_4;
+  typedef short int_2;
+  typedef unsigned short uint_2;
+  typedef float r_4;
+  typedef double r_8;
+  typedef long long int_8;
+  typedef unsigned long long uint_8;
+
+#define  SWAP 0
+#define  SWAPDEFAUT   0
+
+/* Check linux on other machines than Intel */
+#elif defined(OS_LINUX)
+/* Sizes OK for PowerPC, Alpha, Intel    */
+/* On Alpha, long is 8 bytes             */
+  typedef signed char int_1;
+  typedef unsigned char uint_1;
+  typedef int int_4;
+  typedef unsigned int uint_4;
+  typedef short int_2;
+  typedef unsigned short uint_2;
+  typedef float r_4;
+  typedef double r_8;
+  typedef long long int_8;
+  typedef unsigned long long uint_8;
+
+#if defined(powerpc) || (__alpha__)
+#define SWAP 0
+#define SWAPDEFAUT 0
+#else
+#define  SWAP 1
+#define  SWAPDEFAUT   1
+#endif
+
+#elif defined(OS_MACOS)
+
+  typedef signed char int_1;
+  typedef unsigned char uint_1;
+  typedef long int_4;
+  typedef unsigned long uint_4;
+  typedef short int_2;
+  typedef unsigned short uint_2;
+  typedef float r_4;
+  typedef double r_8;
+  typedef long long int_8;
+  typedef unsigned long long uint_8;
+
+#define  SWAP 0
+#define  SWAPDEFAUT   0
+
+#elif defined(OS_MACOSX)
+
+  typedef signed char int_1;
+  typedef unsigned char uint_1;
+  typedef int int_4;
+  typedef unsigned int uint_4;
+  typedef short int_2;
+  typedef unsigned short uint_2;
+  typedef float r_4;
+  typedef double r_8;
+  typedef long long int_8;
+  typedef unsigned long long uint_8;
+  typedef unsigned char pistring[256];
+//  typedef void (*Callback)(void* userData);
+
+#define  SWAP 0
+#define  SWAPDEFAUT   0
+
+
+#else
+#error  Undefined Machine/OS type in machdefs.h
+#endif
+
+
+
+#if SWAP==1
+#define IS_BIG_ENDIAN 0
+#else
+#define IS_BIG_ENDIAN 1
+#endif
+
+
+/***********************************************************************/
+/* Find Compiler                                                       */
+/***********************************************************************/
+
+/*    __MWERKS__   : Metrowerks Codewarrior (>= PRO 4)                 */
+/*    __DECCXX     : DEC CXX, version >= 6 is required                 */
+/*    __GNUG__     : GNU C++ 2.8.1, egcs ??                            */
+/*    __aCC__      : aCC on HP                                         */
+/*    __KCC__      : KCC, version >= 3.3 is required                   */
+/*    __SGICC__    : SGI (IRIX64) CC compiler                          */
+
+/***********************************************************************/
+/* Compiler-specific stuff                                             */
+/***********************************************************************/
+
+/* Some features will be *required* for Planck. Which ones ?               */
+  
+/*   ANSI_TEMPLATES        : use ANSI syntax for explicit templates        */
+/*   GNUG_TEMPLATES        : use GNU syntax for explicit templates         */
+/*   PRAGMA_TEMPLATES      : use pragma template, a la cxx                 */
+/*   COMPILER_EXCEPTIONS   : knows about exceptions  --- required ?        */ 
+/*   STREAMPOS_IS_CLASS    : streampos is a real class                     */
+/*   ITER_TAG              : use iter_tag for iterator qualifiers in STL   */
+/*   NO_STRSTREAM          : does not have strstream                       */
+/*   NO_EXPLICIT           : does not know about explicit keyword          */
+/*   HAS_IOS_BIN                                                           */
+/*   HAS_IOS_NOCREATE                                                      */
+/*   HAS_VEC_NEW           : operator new[]                                */
+/*   CC_HAS_RTTI_SUPPORT     has Run Time Type Identification support      */
+/*   ANSI_IO               : rdbuf()->pubseekoff rather than seekg         */
+/*   HAS_STR_NPOS          : has string::npos and not a global NPOS        */
+/*   NO_IOS_COMPLEX        : does not have operator << defined for complex */
+
+
+/* The following is true for most compilers */
+
+#ifndef HAS_VEC_NEW
+#define HAS_VEC_NEW
+#endif
+
+#ifndef COMPILER_EXCEPTIONS
+#define COMPILER_EXCEPTIONS
+#endif
+
+#ifndef  CC_HAS_RTTI_SUPPORT 
+#define  CC_HAS_RTTI_SUPPORT 
+#endif
+
+/* now the specific things */
+
+#ifdef __MWERKS__
+#define ANSI_TEMPLATES
+#undef  HAS_VEC_NEW
+#define NO_STRSTREAM
+//#define STREAMPOS_IS_CLASS
+#define ITER_TAG
+#define HAS_IOS_BIN 
+#define HAS_IOS_NOCREATE 
+#define HAS_STR_NPOS
+#endif
+
+#ifdef __GNUG__
+#define ANSI_TEMPLATES
+// #define GNU_TEMPLATES
+#define HAS_STR_NPOS
+#define HAS_IOS_BIN
+#define HAS_IOS_NOCREATE
+#endif
+
+#ifdef __DECCXX
+#define HAS_STR_NPOS
+#define ITER_TAG
+#define __CXX_PRAGMA_TEMPLATES__
+#define PRAGMA_TEMPLATES
+#endif
+
+#if defined (__aCC__)  
+#ifndef ANSI_TEMPLATES
+#define ANSI_TEMPLATES
+#endif
+#endif
+
+#if defined(__KCC__)
+/* KCC V 3.2 ne compile pas  i/ostream s ; long p = s.tellg();  OK en  V 3.3 */
+#define HAS_STR_NPOS
+#ifndef ANSI_TEMPLATES
+#define ANSI_TEMPLATES
+#endif
+#endif
+
+#if defined(__SGICC__)
+#define HAS_STR_NPOS
+#ifndef ANSI_TEMPLATES
+#define ANSI_TEMPLATES
+#endif
+#endif
+
+/* Get things has homogeneous as possible between compilers */
+
+#ifdef HAS_STR_NPOS
+#define NPOS string::npos
+#else
+#define NPOS (size_t)-1
+#endif
+
+#ifndef __GNUG__
+#define __PRETTY_FUNCTION__ __FILE__ " __LINE__ "
+#ifndef __FUNCTION__
+#define __FUNCTION__ __FILE__ " __LINE__ "
+#endif
+#ifndef __KCC__
+#define __attribute__(_x_)
+#endif
+#endif
+
+#ifdef NO_EXPLICIT
+#define explicit
+#endif
+
+#ifdef HAS_IOS_BIN
+#define IOS_BIN ios::binary
+#else
+#define IOS_BIN 0
+#endif
+
+#ifdef ANSI_IO
+#define seekg(p_, m_) rdbuf()->pubseekoff(p_,m_)
+#define seekp(p_, m_) rdbuf()->pubseekoff(p_,m_)
+#endif
+
+#ifdef __MWERKS__
+//#define hypot(_x_,_y_) sqrt((_x_)*(_x_) + (_y_)*(_y_))
+#define random() (rand()*65538.0 + rand()*2. + rand())
+#define srandom srand
+#define initstate(seed, tab, n) srand(seed)
+#define nice(_x)
+
+#ifdef __cplusplus
+#include <string.h>
+#include <string>
+inline bool operator< (string const& s1, string const& s2)
+{ return (strcmp(s1.c_str(), s2.c_str()) < 0); }
+#endif
+#endif
+
+#ifdef OS_MACOSX
+#define NO_VALUES_H
+/* BMX */
+#include "PI_Prefix.h"
+/* #include "osx_values.h" */
+/* Faute de mieux pour le moment : */
+#define drand48() ((double)(random())/LONG_MAX)
+#endif
+
+
+/********************************************************/
+/* Outil d'impressions pour debug */
+#define PR(_data_)  {cout<<" "<<#_data_<<" "<<_data_;}
+#define CR {cout<<"\n"<<flush;}
+/* ********************************************************/
+
+/* ---- Activation des flags de debug/bound checking  ----- */
+#ifdef SOPHYA_DEBUG
+#define SO_BOUNDCHECKING
+#endif
+
+/* ---- La taille et les index des tableaux ---- */
+#ifdef SGI_ARCH64
+typedef int_8 sa_size_t ;
+#else
+typedef int_4 sa_size_t ;
+#endif
+
+/* Compatibilite, avant de migrer tout le code en "PLANCK" */
+
+#ifdef __cplusplus
+/* Standard C++ library classes are in the namespace std  */
+namespace std { }
+using namespace std;
+/*  SOPHYA classes are in namespace SOPHYA  */
+namespace SOPHYA {}
+using namespace SOPHYA;
+#define EXPLICIT explicit
+#endif
+
+#endif
Index: /trunk/SophyaPI/PI/Quartz/pibwdgquartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pibwdgquartz.cpp	(revision 4076)
+++ /trunk/SophyaPI/PI/Quartz/pibwdgquartz.cpp	(revision 4077)
@@ -4,57 +4,109 @@
  *
  *  Created by Bruno MANSOUX on 19/09/08.
- *  Copyright 2008 __MyCompanyName__. All rights reserved.
  *
  */
 
 #include "pibwdgquartz.h"
+#include "PIContainerQuartz.h"
 
-PIBaseWdgQuartz::PIBaseWdgQuartz(PIContainerGen *par, const char *nom,int sx, int sy, int px, int py)
+OSStatus BaseWdgQuartzEventHandler (EventHandlerCallRef myHandler,EventRef event, void *userData);
+
+PIBaseWdgQuartz::PIBaseWdgQuartz(PIContainerGen *par, const char *nom, int sx, int sy, int px, int py)
 : PIBaseWdgGen(par,nom,sx,sy,px,py)
 {
+	HIRect localHIRect;
+	HIViewRef rootView;
+	HIViewRef contentView;
+	OSStatus err;
+	
+	rootView = ((PIWdg*)par)->GetHIViewRef();
+	err = HIViewGetBounds (rootView, &localHIRect);
+												
+	err = HIScrollViewCreate(kHIScrollViewOptionsVertScroll | kHIScrollViewOptionsHorizScroll, &wdgHIView);
+	err += HIViewSetVisible (wdgHIView, true);	
+	
+	err += HIViewFindByID(rootView, kHIViewWindowContentID, &contentView);
+	err += HIViewAddSubview (contentView, wdgHIView);
+
+	err += HIViewGetBounds (wdgHIView, &localHIRect);
+	
+	localHIRect.origin.x = (float)px;
+	localHIRect.origin.y	= (float)py;
+	localHIRect.size.width = (float)sx; 
+	localHIRect.size.height = (float)sy;
+	
+	err = HIViewSetFrame (wdgHIView, &localHIRect);
+	
+	err += HIViewGetFrame (wdgHIView, &localHIRect);
+	
+	printf("PIBaseWdgQuartz::PIBaseWdgQuartz Set Frame (%g %g) [%g %g] err : %d \n",
+											localHIRect.origin.x, localHIRect.origin.y,
+											localHIRect.size.width, localHIRect.size.height,
+											err);
+
+	err = InstallEventHandler (GetControlEventTarget (wdgHIView),
+								NewEventHandlerUPP (BaseWdgQuartzEventHandler),
+								GetEventTypeCount (basewdgSpec),
+								(const EventTypeSpec*)&basewdgSpec,
+								(void *) this,
+								NULL);
+
+	HIViewRender(wdgHIView);
+
+	mWGrC = new PIGraphicWin(this);
 }
 
+/* --Methode-- */
 PIBaseWdgQuartz::~PIBaseWdgQuartz()
 {
 }
 
+/* --Methode-- */
 void PIBaseWdgQuartz::FinishCreate()
 {
 }
 
+/* --Methode-- */
 void PIBaseWdgQuartz::ActivatePtrCross()
 {
 }
  
+/* --Methode-- */
 void PIBaseWdgQuartz::ActivateButton(int bid)
 {
 }
  
+/* --Methode-- */
 void PIBaseWdgQuartz::ActivateMove(int bid)
 {
 }
  
+/* --Methode-- */
 void PIBaseWdgQuartz::ActivateKeyboard()
 {
 }
  
+/* --Methode-- */
 void PIBaseWdgQuartz::SelPointerShape(PIPointer ptr)
 {
 }
  
+/* --Methode-- */
 PIPointer PIBaseWdgQuartz::GetPointerShape()
 {
+	return PI_ArrowPointer;
 }
  
+/* --Methode-- */
 void PIBaseWdgQuartz::AssignKeyboard()
 {
 }
 
-// Acces aux caracteristiques du dernier evenement 
+/* --Methode-- */
 void PIBaseWdgQuartz::GetLastEventInfo(PIKeyModifier& kmod, unsigned long& tm)
 {
 }
 
-// On redefinit IsVisible() pour tenir compte de l appel a FinsihCreate  
+/* --Methode-- */
 bool PIBaseWdgQuartz::IsVisible()
 {
@@ -62,14 +114,78 @@
 }
 
-//  Fonction qui doit etre appelee pour rafraichir la fenetre 
+/* --Methode-- */
 void PIBaseWdgQuartz::Refresh()
 {
+	printf("PIBaseWdgQuartz::Refresh ");
+	EventRef	rEvent;
+	OSStatus err;
+	
+	err = CreateEvent( NULL,  kEventClassControl, kEventControlDraw,
+				GetCurrentEventTime(), kEventAttributeNone, &rEvent );
+	SetEventParameter( rEvent, kEventParamCGContextRef, typeCGContextRef, sizeof (CGContextRef), mWGrC->GetCGContext());
+
+	SendEventToEventTarget(rEvent, GetControlEventTarget (wdgHIView));
+	
+	HIRect hiRect;
+	HIViewGetFrame(wdgHIView, &hiRect);
+
+	CGContextRestoreGState (mWGrC->GetCGContext());
+	printf(" cg : %lx ox : %g oy : %g width : %g height : %g \n",
+			mWGrC->GetCGContext(), hiRect.origin.x, hiRect.origin.y, hiRect.size.width, hiRect.size.height);
+	// mWGrC->SetGCRect(hiRect.origin.x, hiRect.origin.y, hiRect.size.width, hiRect.size.height);	
+	// Draw(mWGrC, 0, 0, XSize(), YSize());
+
 	return;
 }
 
-//  Appel depuis le PIXtBaseWidget uniquement (ExposeEvt de Xt )
-void PIBaseWdgQuartz::eXposeProcess(int x0, int y0, int dx, int dy)
+/* --Methode-- */
+void PIBaseWdgQuartz::eXposeProcess(CGContextRef cg, int x0, int y0, int dx, int dy)
 {
+	printf("PIBaseWdgQuartz::ExposeProcess \n");
+	CGContextSaveGState(cg);
+	mWGrC->SetCGContext(cg);
+	mWGrC->SetCTM(CGContextGetCTM(cg));
+	Draw(mWGrC, x0, y0, dx, dy);
+
 	return;
 }
  
+/* ============================================================================================================ */
+/* ============================================================================================================ */
+static int counterDraw = 0;
+// Handler
+OSStatus BaseWdgQuartzEventHandler (EventHandlerCallRef myHandler, EventRef event, void *userData)
+{
+	OSStatus status = noErr;
+	
+	counterDraw++;
+	printf(" BaseWdgQuartzEventHandler (%d) : ", counterDraw);
+	PIGetEventName(event);
+
+	PIBaseWdgQuartz* wdg = (PIBaseWdgQuartz*) userData;
+
+	CGContextRef cg;
+		
+    status = GetEventParameter (event, kEventParamCGContextRef, typeCGContextRef, NULL, sizeof (CGContextRef), NULL, &cg);
+
+	if (status != noErr)
+	{
+		printf(" err = %d \n",status);
+	}
+	else
+	{	
+		// wdg->SetQuartzCGContext(cg);
+		HIViewRef view = wdg->GetHIViewRef();
+		HIRect hiRect;
+		HIViewGetFrame(view, &hiRect);
+		// Pour le moment on rafraichit toute la vue
+		int ox = (int)(hiRect.origin.x);
+		int oy = (int)(hiRect.origin.x);
+		int dx = (int)(hiRect.size.width); 
+		int dy = (int)(hiRect.size.height);
+		printf(" BaseWdgQuartzEventHandler cg : %lx [%d %d] Frame [%d, %d] \n", (unsigned long)cg, ox, oy, dx, dy);
+		wdg->eXposeProcess(cg, 0 , 0, dx, dy);
+	}
+
+	return status;
+}
Index: /trunk/SophyaPI/PI/Quartz/pibwdgquartz.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pibwdgquartz.h	(revision 4076)
+++ /trunk/SophyaPI/PI/Quartz/pibwdgquartz.h	(revision 4077)
@@ -15,4 +15,27 @@
 #include "pigraphquartz.h"
 #include "pigraphps.h"
+
+/*
+static const EventTypeSpec basewdgSpec[] = {
+ 											 { kEventClassWindow, kEventWindowClose},
+ 											 { kEventClassWindow, kEventWindowResizeCompleted},
+ 											 { kEventClassWindow, kEventWindowDrawContent},
+											 { kEventClassWindow, kEventWindowBoundsChanged },
+											 { kEventClassHIObject, kEventHIObjectConstruct },
+											 { kEventClassHIObject, kEventHIObjectInitialize },
+											 { kEventClassHIObject, kEventHIObjectDestruct },
+											  { kEventClassControl, kEventControlDraw},
+											  { kEventClassControl, kEventControlClick},
+											  { kEventClassControl, kEventControlBoundsChanged},
+											  { kEventClassControl, kEventControlOwningWindowChanged },
+											  { kEventClassControl, kEventControlInitialize },
+											  { kEventClassControl, kEventControlGetPartRegion },
+											  { kEventClassControl, kEventControlHitTest }
+											 };
+
+*/
+
+static const EventTypeSpec basewdgSpec[] = {{ kEventClassControl, kEventControlDraw}};
+
 
 class PIBaseWdgQuartz : public PIBaseWdgGen
@@ -49,9 +72,9 @@
 
 //  Appel depuis le PIXtBaseWidget uniquement (ExposeEvt de Xt )
-  virtual void       eXposeProcess(int x0, int y0, int dx, int dy);
+  virtual void       eXposeProcess(CGContextRef cg, int x0, int y0, int dx, int dy);
  
 protected:
   void               Init();
-  PIPointer mPtrS;
+  PIPointer          mPtrS;
 // pour s'assurer que le bon FinishCreate() est appele - pb lie aux tables de fonctions
 // virtuelles des classes qui sont remplies au fur et a mesure des constructeurs
Index: /trunk/SophyaPI/PI/Quartz/pieventquartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pieventquartz.cpp	(revision 4077)
+++ /trunk/SophyaPI/PI/Quartz/pieventquartz.cpp	(revision 4077)
@@ -0,0 +1,90 @@
+/*
+ *  pieventquartz.cpp
+ *  PI
+ *
+ *  Created by Bruno MANSOUX on 02/03/10.
+ *
+ */
+
+#include "pieventquartz.h"
+
+void PIGetEventName (EventRef event)
+{
+    UInt32 eventClass = GetEventClass( event );
+    UInt32 eventKind = GetEventKind( event );
+
+	switch(eventClass)
+	{
+		case kEventClassControl:
+		{
+			switch (eventKind)
+			{
+			case kEventControlDraw:
+			printf(" kEventControlDraw \n");
+			break;
+			case kEventControlOwningWindowChanged:
+			printf(" kEventControlOwningWindowChanged\n");
+			break;
+			case kEventControlInitialize:
+			printf(" kEventControlInitialize\n");
+			break;
+			case kEventControlHitTest:
+			printf("kEventControlHitTest\n");
+			break;
+			case kEventControlGetPartRegion:
+			printf("kEventControlGetPartRegion\n");
+			break;
+			case kEventControlBoundsChanged:
+			printf(" kEventControlBoundsChanged \n");
+			break;
+			case kEventControlClick:
+			printf(" kEventControlClick \n");
+			break;
+			}
+		}
+		break;
+		
+		case kEventClassWindow:
+		{
+			switch (eventKind)
+			{
+			case kEventWindowClose:
+			printf(" kEventWindowClose \n");
+			break;
+			case kEventWindowDrawContent:
+			printf(" kEventWindowDrawContent \n");
+			break;
+			case kEventWindowBoundsChanged:
+			printf(" kEventWindowBoundsChanged \n");
+			break;
+			case kEventWindowResizeCompleted:
+			printf(" kEventWindowResizeCompleted \n");
+			break;
+			}
+		}
+		break;
+		
+		case kEventClassHIObject:
+		{
+			switch (eventKind)
+			{
+			case kEventHIObjectConstruct:
+			printf(" kEventHIObjectConstruct \n");
+			break;
+			case kEventHIObjectInitialize:
+			printf(" kEventHIObjectInitialize\n");
+			break;
+			case kEventHIObjectDestruct:
+			printf(" kEventHIObjectDestruct\n");
+			break;
+			}
+		}
+		break;
+		
+		default:
+		break;
+	}
+	
+	return;
+}
+
Index: /trunk/SophyaPI/PI/Quartz/pieventquartz.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pieventquartz.h	(revision 4077)
+++ /trunk/SophyaPI/PI/Quartz/pieventquartz.h	(revision 4077)
@@ -0,0 +1,17 @@
+/*
+ *  pieventquartz.h
+ *  PI
+ *
+ *  Created by Bruno MANSOUX on 02/03/10.
+ *
+ */
+
+#ifndef PIEVENTQUARTZ_H_SEEN
+#define PIEVENTQUARTZ_H_SEEN
+
+#include  <Carbon/Carbon.h>
+
+void PIGetEventName (EventRef event);
+
+
+#endif
Index: /trunk/SophyaPI/PI/Quartz/pigraphquartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pigraphquartz.cpp	(revision 4076)
+++ /trunk/SophyaPI/PI/Quartz/pigraphquartz.cpp	(revision 4077)
@@ -11,7 +11,4 @@
 #define NMAXCOL  32
 static  PIQuartzColor colpix[NMAXCOL];
-static const EventTypeSpec  gqHIViewSpec[] = {kEventClassControl,kEventControlDraw };
-
-OSStatus MyDrawEventHandler (EventHandlerCallRef myHandler,EventRef event, void *userData);
 
 /* --Methode-- */
@@ -20,25 +17,20 @@
 {
 	OSStatus err;
-	HIViewRef rootView;
-    HIRect      bounds;
-		
-	rootView = wdg->GetHIViewRef();
-	err = HIViewFindByID(rootView, kHIViewWindowContentID,&hiViewRef);
-	HIViewGetBounds (rootView, &bounds);
+    HIRect frame;
+	int value;
+			
+	hiViewRef = wdg->GetHIViewRef();
 	
-	printf("View Bounds (%g %g) [%g %g] \n",bounds.origin.x,bounds.origin.y,
-											bounds.size.width,bounds.size.height);
-
-	err = InstallEventHandler (GetControlEventTarget (hiViewRef),
-                            NewEventHandlerUPP (MyDrawEventHandler),
-                            GetEventTypeCount (gqHIViewSpec),
-                            (const EventTypeSpec*)&gqHIViewSpec,
-                            (void *) cgContext,
-                            NULL);
-	cgWindow =  HIViewGetWindow(rootView);
-	ShowWindow(cgWindow);
-	SetPortWindowPort(cgWindow);
-	QDBeginCGContext (GetWindowPort (cgWindow), &cgContext);
-	CGContextFlush(cgContext);
+	value = HIViewGetValue (hiViewRef);
+	
+	err = HIViewGetFrame (hiViewRef, &frame);
+	
+	printf("PIGraphicQuartz::PIGraphicQuartz View Frame (%g %g) [%g %g] err : %d value : %d \n",
+											frame.origin.x, frame.origin.y,
+											frame.size.width, frame.size.height, 
+											err, value);
+
+	cgWindow =  HIViewGetWindow(hiViewRef);
+	cgContext = NULL ;	
 }
 
@@ -50,9 +42,8 @@
 }
 
-
 /* --Methode-- */
 PIGraphicQuartz::~PIGraphicQuartz()
 {
-	QDEndCGContext (GetWindowPort(cgWindow), &cgContext);
+	// QDEndCGContext (GetWindowPort(cgWindow), &cgContext);
 }
 
@@ -281,5 +272,4 @@
 	return;
 }
-
 
 /* --Methode-- */
@@ -897,17 +887,46 @@
 }
 
-
-/* Methode Generale */
-OSStatus MyDrawEventHandler (EventHandlerCallRef myHandler, EventRef event, void *userData)
-{
-	OSStatus status = noErr;
- 
-    status = GetEventParameter (event, // 1
-                            kEventParamCGContextRef,
-                            typeCGContextRef,
-                            NULL,
-                            sizeof (CGContextRef),
-                            NULL,
-                            &userData);
-    return status;
-}
+/* --Methode-- */
+void PIGraphicQuartz::SetCGContext(CGContextRef cg)
+{
+	if (cgContext != NULL)
+	{
+		printf("PIGraphicQuartz::SetCGContext Release CGContext %lx \n", (unsigned long)cgContext);
+		CGContextRelease (cgContext);
+		cgContext = NULL;
+	}
+	
+	cgContext = CGContextRetain(cg);
+
+	HIRect hiRect;
+	HIViewGetFrame(hiViewRef, &hiRect);
+
+	printf("PIGraphicQuartz::SetCGContext Frame ox : %g oy : %g width : %g height : %g \n",
+			hiRect.origin.x, hiRect.origin.y, hiRect.size.width, hiRect.size.height);
+	// SetGCRect(hiRect.origin.x, hiRect.origin.y, hiRect.size.width, hiRect.size.height);
+	return;
+}
+
+/* --Methode-- */
+void PIGraphicQuartz::SetCTM(CGAffineTransform cat)
+{
+	cgAffineTransform.a = cat.a;
+	cgAffineTransform.b = cat.b;
+	cgAffineTransform.c = cat.c;
+	cgAffineTransform.d = cat.d;
+	cgAffineTransform.tx = cat.tx;
+	cgAffineTransform.ty = cat.ty;
+	return;
+}
+
+
+/* --Methode-- */
+void PIGraphicQuartz::SetGCRect(float x0, float y0, float dx, float dy)
+{
+	printf("PIGraphicQuartz::SetGCRect %g %g %g %g \n", x0, y0, dx, dy);
+//	CGAffineTransform cat;
+	CGContextScaleCTM (cgContext, 1., 1.);
+	CGContextTranslateCTM (cgContext, x0, y0 + dy);
+//	CGContextRotateCTM (cgContext, 0.);
+	return;
+}
Index: /trunk/SophyaPI/PI/Quartz/pigraphquartz.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pigraphquartz.h	(revision 4076)
+++ /trunk/SophyaPI/PI/Quartz/pigraphquartz.h	(revision 4077)
@@ -20,4 +20,5 @@
 #include "pisysdep.h"
 #include "pigraphgen.h"
+#include "pieventquartz.h"
 
 class PIGraphicQuartz : public PIGraphicGen
@@ -91,4 +92,11 @@
   static PIQuartzColor    GetPixelValueforColor(PIColors col);
 
+// pour recuperer Quartz2D Drawing Context
+  inline CGContextRef GetCGContext() {return cgContext;}
+  void SetCGContext(CGContextRef cg);
+  void SetGCRect(float x0, float y0, float dx, float dy);
+  inline CGAffineTransform GetCTM() {return cgAffineTransform;}
+  void SetCTM(CGAffineTransform cat);
+
 protected:
   void           SelectFont(int isz, int jat);
@@ -115,4 +123,5 @@
   HIViewRef hiViewRef;
   CGContextRef cgContext;
+  CGAffineTransform cgAffineTransform;
   WindowRef cgWindow;
 };
